#ifndef JS_HPP
#define JS_HPP
using namespace StandardComponents;

struct JsTarget: Target {
    print_functions_pair printFunctions() final { return make_pair("util.write", "console.log"); }
    bool use_uniqueLineSeparator() final { return true; }
    unordered_task_map getTaskMap() final {
        return {
            make_task(Define,
                output << (parseComponent.final ? "const " : "let ") << parseComponent.name << " = ";
                transpileTree(parseComponent.content);
            ),
            make_task(types::String, stringInterpolation(parseComponent.content);),
            make_task(Function,
                output << "function " << parseComponent.name << '(';
                separate_transpileTree(parseComponent.parameters, ", ");
                output << ") {";
                if (newLines and not parseComponent.empty()) output << separator << indentation;
                separate_transpileTree(parseComponent, 1);
                if (newLines and not parseComponent.empty()) output << separator;
                output << '}';
            )
        };
    }
    using Target::Target;
};

#endif